1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
6# if --tee was passed, write the output not only to the terminal, but
7# additionally to the file test-results/$BASENAME.out, too.
8case "$GIT_TEST_TEE_STARTED, $* " in
9done,*)
10 # do not redirect again
11 ;;
12*' --tee '*|*' --va'*)
13 mkdir -p test-results
14 BASE=test-results/$(basename "$0" .sh)
15 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16 echo $? > $BASE.exit) | tee $BASE.out
17 test "$(cat $BASE.exit)" = 0
18 exit
19 ;;
20esac
21
22# Keep the original TERM for say_color
23ORIGINAL_TERM=$TERM
24
25# For repeatability, reset the environment to known value.
26LANG=C
27LC_ALL=C
28PAGER=cat
29TZ=UTC
30TERM=dumb
31export LANG LC_ALL PAGER TERM TZ
32EDITOR=:
33unset VISUAL
34unset GIT_EDITOR
35unset AUTHOR_DATE
36unset AUTHOR_EMAIL
37unset AUTHOR_NAME
38unset COMMIT_AUTHOR_EMAIL
39unset COMMIT_AUTHOR_NAME
40unset EMAIL
41unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42unset GIT_AUTHOR_DATE
43GIT_AUTHOR_EMAIL=author@example.com
44GIT_AUTHOR_NAME='A U Thor'
45unset GIT_COMMITTER_DATE
46GIT_COMMITTER_EMAIL=committer@example.com
47GIT_COMMITTER_NAME='C O Mitter'
48unset GIT_DIFF_OPTS
49unset GIT_DIR
50unset GIT_WORK_TREE
51unset GIT_EXTERNAL_DIFF
52unset GIT_INDEX_FILE
53unset GIT_OBJECT_DIRECTORY
54unset GIT_CEILING_DIRECTORIES
55unset SHA1_FILE_DIRECTORIES
56unset SHA1_FILE_DIRECTORY
57unset GIT_NOTES_REF
58unset GIT_NOTES_DISPLAY_REF
59unset GIT_NOTES_REWRITE_REF
60unset GIT_NOTES_REWRITE_MODE
61GIT_MERGE_VERBOSITY=5
62export GIT_MERGE_VERBOSITY
63export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
64export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
65export EDITOR
66GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
67
68# Protect ourselves from common misconfiguration to export
69# CDPATH into the environment
70unset CDPATH
71
72unset GREP_OPTIONS
73
74case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
75 1|2|true)
76 echo "* warning: Some tests will not work if GIT_TRACE" \
77 "is set as to trace on STDERR ! *"
78 echo "* warning: Please set GIT_TRACE to something" \
79 "other than 1, 2 or true ! *"
80 ;;
81esac
82
83# Convenience
84#
85# A regexp to match 5 and 40 hexdigits
86_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
87_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
88
89# Each test should start with something like this, after copyright notices:
90#
91# test_description='Description of this test...
92# This test checks if command xyzzy does the right thing...
93# '
94# . ./test-lib.sh
95[ "x$ORIGINAL_TERM" != "xdumb" ] && (
96 TERM=$ORIGINAL_TERM &&
97 export TERM &&
98 [ -t 1 ] &&
99 tput bold >/dev/null 2>&1 &&
100 tput setaf 1 >/dev/null 2>&1 &&
101 tput sgr0 >/dev/null 2>&1
102 ) &&
103 color=t
104
105while test "$#" -ne 0
106do
107 case "$1" in
108 -d|--d|--de|--deb|--debu|--debug)
109 debug=t; shift ;;
110 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
111 immediate=t; shift ;;
112 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
113 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
114 -h|--h|--he|--hel|--help)
115 help=t; shift ;;
116 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
117 verbose=t; shift ;;
118 -q|--q|--qu|--qui|--quie|--quiet)
119 quiet=t; shift ;;
120 --with-dashes)
121 with_dashes=t; shift ;;
122 --no-color)
123 color=; shift ;;
124 --no-python)
125 # noop now...
126 shift ;;
127 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
128 valgrind=t; verbose=t; shift ;;
129 --tee)
130 shift ;; # was handled already
131 --root=*)
132 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
133 shift ;;
134 *)
135 echo "error: unknown test option '$1'" >&2; exit 1 ;;
136 esac
137done
138
139if test -n "$color"; then
140 say_color () {
141 (
142 TERM=$ORIGINAL_TERM
143 export TERM
144 case "$1" in
145 error) tput bold; tput setaf 1;; # bold red
146 skip) tput bold; tput setaf 2;; # bold green
147 pass) tput setaf 2;; # green
148 info) tput setaf 3;; # brown
149 *) test -n "$quiet" && return;;
150 esac
151 shift
152 printf "* %s" "$*"
153 tput sgr0
154 echo
155 )
156 }
157else
158 say_color() {
159 test -z "$1" && test -n "$quiet" && return
160 shift
161 echo "* $*"
162 }
163fi
164
165error () {
166 say_color error "error: $*"
167 GIT_EXIT_OK=t
168 exit 1
169}
170
171say () {
172 say_color info "$*"
173}
174
175test "${test_description}" != "" ||
176error "Test script did not set test_description."
177
178if test "$help" = "t"
179then
180 echo "$test_description"
181 exit 0
182fi
183
184exec 5>&1
185if test "$verbose" = "t"
186then
187 exec 4>&2 3>&1
188else
189 exec 4>/dev/null 3>/dev/null
190fi
191
192test_failure=0
193test_count=0
194test_fixed=0
195test_broken=0
196test_success=0
197
198die () {
199 code=$?
200 if test -n "$GIT_EXIT_OK"
201 then
202 exit $code
203 else
204 echo >&5 "FATAL: Unexpected exit with code $code"
205 exit 1
206 fi
207}
208
209GIT_EXIT_OK=
210trap 'die' EXIT
211
212# The semantics of the editor variables are that of invoking
213# sh -c "$EDITOR \"$@\"" files ...
214#
215# If our trash directory contains shell metacharacters, they will be
216# interpreted if we just set $EDITOR directly, so do a little dance with
217# environment variables to work around this.
218#
219# In particular, quoting isn't enough, as the path may contain the same quote
220# that we're using.
221test_set_editor () {
222 FAKE_EDITOR="$1"
223 export FAKE_EDITOR
224 EDITOR='"$FAKE_EDITOR"'
225 export EDITOR
226}
227
228test_decode_color () {
229 sed -e 's/.\[1m/<WHITE>/g' \
230 -e 's/.\[31m/<RED>/g' \
231 -e 's/.\[32m/<GREEN>/g' \
232 -e 's/.\[33m/<YELLOW>/g' \
233 -e 's/.\[34m/<BLUE>/g' \
234 -e 's/.\[35m/<MAGENTA>/g' \
235 -e 's/.\[36m/<CYAN>/g' \
236 -e 's/.\[m/<RESET>/g'
237}
238
239q_to_nul () {
240 perl -pe 'y/Q/\000/'
241}
242
243q_to_cr () {
244 tr Q '\015'
245}
246
247append_cr () {
248 sed -e 's/$/Q/' | tr Q '\015'
249}
250
251remove_cr () {
252 tr '\015' Q | sed -e 's/Q$//'
253}
254
255test_tick () {
256 if test -z "${test_tick+set}"
257 then
258 test_tick=1112911993
259 else
260 test_tick=$(($test_tick + 60))
261 fi
262 GIT_COMMITTER_DATE="$test_tick -0700"
263 GIT_AUTHOR_DATE="$test_tick -0700"
264 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
265}
266
267# Call test_commit with the arguments "<message> [<file> [<contents>]]"
268#
269# This will commit a file with the given contents and the given commit
270# message. It will also add a tag with <message> as name.
271#
272# Both <file> and <contents> default to <message>.
273
274test_commit () {
275 file=${2:-"$1.t"}
276 echo "${3-$1}" > "$file" &&
277 git add "$file" &&
278 test_tick &&
279 git commit -m "$1" &&
280 git tag "$1"
281}
282
283# Call test_merge with the arguments "<message> <commit>", where <commit>
284# can be a tag pointing to the commit-to-merge.
285
286test_merge () {
287 test_tick &&
288 git merge -m "$1" "$2" &&
289 git tag "$1"
290}
291
292# This function helps systems where core.filemode=false is set.
293# Use it instead of plain 'chmod +x' to set or unset the executable bit
294# of a file in the working directory and add it to the index.
295
296test_chmod () {
297 chmod "$@" &&
298 git update-index --add "--chmod=$@"
299}
300
301# Use test_set_prereq to tell that a particular prerequisite is available.
302# The prerequisite can later be checked for in two ways:
303#
304# - Explicitly using test_have_prereq.
305#
306# - Implicitly by specifying the prerequisite tag in the calls to
307# test_expect_{success,failure,code}.
308#
309# The single parameter is the prerequisite tag (a simple word, in all
310# capital letters by convention).
311
312test_set_prereq () {
313 satisfied="$satisfied$1 "
314}
315satisfied=" "
316
317test_have_prereq () {
318 case $satisfied in
319 *" $1 "*)
320 : yes, have it ;;
321 *)
322 ! : nope ;;
323 esac
324}
325
326# You are not expected to call test_ok_ and test_failure_ directly, use
327# the text_expect_* functions instead.
328
329test_ok_ () {
330 test_success=$(($test_success + 1))
331 say_color "" " ok $test_count: $@"
332}
333
334test_failure_ () {
335 test_failure=$(($test_failure + 1))
336 say_color error "FAIL $test_count: $1"
337 shift
338 echo "$@" | sed -e 's/^/ /'
339 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
340}
341
342test_known_broken_ok_ () {
343 test_fixed=$(($test_fixed+1))
344 say_color "" " FIXED $test_count: $@"
345}
346
347test_known_broken_failure_ () {
348 test_broken=$(($test_broken+1))
349 say_color skip " still broken $test_count: $@"
350}
351
352test_debug () {
353 test "$debug" = "" || eval "$1"
354}
355
356test_run_ () {
357 eval >&3 2>&4 "$1"
358 eval_ret="$?"
359 return 0
360}
361
362test_skip () {
363 test_count=$(($test_count+1))
364 to_skip=
365 for skp in $GIT_SKIP_TESTS
366 do
367 case $this_test.$test_count in
368 $skp)
369 to_skip=t
370 esac
371 done
372 if test -z "$to_skip" && test -n "$prereq" &&
373 ! test_have_prereq "$prereq"
374 then
375 to_skip=t
376 fi
377 case "$to_skip" in
378 t)
379 say_color skip >&3 "skipping test: $@"
380 say_color skip "skip $test_count: $1"
381 : true
382 ;;
383 *)
384 false
385 ;;
386 esac
387}
388
389test_expect_failure () {
390 test "$#" = 3 && { prereq=$1; shift; } || prereq=
391 test "$#" = 2 ||
392 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
393 if ! test_skip "$@"
394 then
395 say >&3 "checking known breakage: $2"
396 test_run_ "$2"
397 if [ "$?" = 0 -a "$eval_ret" = 0 ]
398 then
399 test_known_broken_ok_ "$1"
400 else
401 test_known_broken_failure_ "$1"
402 fi
403 fi
404 echo >&3 ""
405}
406
407test_expect_success () {
408 test "$#" = 3 && { prereq=$1; shift; } || prereq=
409 test "$#" = 2 ||
410 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
411 if ! test_skip "$@"
412 then
413 say >&3 "expecting success: $2"
414 test_run_ "$2"
415 if [ "$?" = 0 -a "$eval_ret" = 0 ]
416 then
417 test_ok_ "$1"
418 else
419 test_failure_ "$@"
420 fi
421 fi
422 echo >&3 ""
423}
424
425test_expect_code () {
426 test "$#" = 4 && { prereq=$1; shift; } || prereq=
427 test "$#" = 3 ||
428 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
429 if ! test_skip "$@"
430 then
431 say >&3 "expecting exit code $1: $3"
432 test_run_ "$3"
433 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
434 then
435 test_ok_ "$2"
436 else
437 test_failure_ "$@"
438 fi
439 fi
440 echo >&3 ""
441}
442
443# test_external runs external test scripts that provide continuous
444# test output about their progress, and succeeds/fails on
445# zero/non-zero exit code. It outputs the test output on stdout even
446# in non-verbose mode, and announces the external script with "* run
447# <n>: ..." before running it. When providing relative paths, keep in
448# mind that all scripts run in "trash directory".
449# Usage: test_external description command arguments...
450# Example: test_external 'Perl API' perl ../path/to/test.pl
451test_external () {
452 test "$#" = 4 && { prereq=$1; shift; } || prereq=
453 test "$#" = 3 ||
454 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
455 descr="$1"
456 shift
457 if ! test_skip "$descr" "$@"
458 then
459 # Announce the script to reduce confusion about the
460 # test output that follows.
461 say_color "" " run $test_count: $descr ($*)"
462 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
463 # to be able to use them in script
464 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
465 # Run command; redirect its stderr to &4 as in
466 # test_run_, but keep its stdout on our stdout even in
467 # non-verbose mode.
468 "$@" 2>&4
469 if [ "$?" = 0 ]
470 then
471 test_ok_ "$descr"
472 else
473 test_failure_ "$descr" "$@"
474 fi
475 fi
476}
477
478# Like test_external, but in addition tests that the command generated
479# no output on stderr.
480test_external_without_stderr () {
481 # The temporary file has no (and must have no) security
482 # implications.
483 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
484 stderr="$tmp/git-external-stderr.$$.tmp"
485 test_external "$@" 4> "$stderr"
486 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
487 descr="no stderr: $1"
488 shift
489 say >&3 "expecting no stderr from previous command"
490 if [ ! -s "$stderr" ]; then
491 rm "$stderr"
492 test_ok_ "$descr"
493 else
494 if [ "$verbose" = t ]; then
495 output=`echo; echo Stderr is:; cat "$stderr"`
496 else
497 output=
498 fi
499 # rm first in case test_failure exits.
500 rm "$stderr"
501 test_failure_ "$descr" "$@" "$output"
502 fi
503}
504
505# This is not among top-level (test_expect_success | test_expect_failure)
506# but is a prefix that can be used in the test script, like:
507#
508# test_expect_success 'complain and die' '
509# do something &&
510# do something else &&
511# test_must_fail git checkout ../outerspace
512# '
513#
514# Writing this as "! git checkout ../outerspace" is wrong, because
515# the failure could be due to a segv. We want a controlled failure.
516
517test_must_fail () {
518 "$@"
519 test $? -gt 0 -a $? -le 129 -o $? -gt 192
520}
521
522# test_cmp is a helper function to compare actual and expected output.
523# You can use it like:
524#
525# test_expect_success 'foo works' '
526# echo expected >expected &&
527# foo >actual &&
528# test_cmp expected actual
529# '
530#
531# This could be written as either "cmp" or "diff -u", but:
532# - cmp's output is not nearly as easy to read as diff -u
533# - not all diff versions understand "-u"
534
535test_cmp() {
536 $GIT_TEST_CMP "$@"
537}
538
539# Most tests can use the created repository, but some may need to create more.
540# Usage: test_create_repo <directory>
541test_create_repo () {
542 test "$#" = 1 ||
543 error "bug in the test script: not 1 parameter to test-create-repo"
544 owd=`pwd`
545 repo="$1"
546 mkdir -p "$repo"
547 cd "$repo" || error "Cannot setup test environment"
548 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
549 error "cannot run git init -- have you built things yet?"
550 mv .git/hooks .git/hooks-disabled
551 cd "$owd"
552}
553
554test_done () {
555 GIT_EXIT_OK=t
556 test_results_dir="$TEST_DIRECTORY/test-results"
557 mkdir -p "$test_results_dir"
558 test_results_path="$test_results_dir/${0%.sh}-$$"
559
560 echo "total $test_count" >> $test_results_path
561 echo "success $test_success" >> $test_results_path
562 echo "fixed $test_fixed" >> $test_results_path
563 echo "broken $test_broken" >> $test_results_path
564 echo "failed $test_failure" >> $test_results_path
565 echo "" >> $test_results_path
566
567 if test "$test_fixed" != 0
568 then
569 say_color pass "fixed $test_fixed known breakage(s)"
570 fi
571 if test "$test_broken" != 0
572 then
573 say_color error "still have $test_broken known breakage(s)"
574 msg="remaining $(($test_count-$test_broken)) test(s)"
575 else
576 msg="$test_count test(s)"
577 fi
578 case "$test_failure" in
579 0)
580 say_color pass "passed all $msg"
581
582 test -d "$remove_trash" &&
583 cd "$(dirname "$remove_trash")" &&
584 rm -rf "$(basename "$remove_trash")"
585
586 exit 0 ;;
587
588 *)
589 say_color error "failed $test_failure among $msg"
590 exit 1 ;;
591
592 esac
593}
594
595# Test the binaries we have just built. The tests are kept in
596# t/ subdirectory and are run in 'trash directory' subdirectory.
597TEST_DIRECTORY=$(pwd)
598if test -n "$valgrind"
599then
600 make_symlink () {
601 test -h "$2" &&
602 test "$1" = "$(readlink "$2")" || {
603 # be super paranoid
604 if mkdir "$2".lock
605 then
606 rm -f "$2" &&
607 ln -s "$1" "$2" &&
608 rm -r "$2".lock
609 else
610 while test -d "$2".lock
611 do
612 say "Waiting for lock on $2."
613 sleep 1
614 done
615 fi
616 }
617 }
618
619 make_valgrind_symlink () {
620 # handle only executables
621 test -x "$1" || return
622
623 base=$(basename "$1")
624 symlink_target=$TEST_DIRECTORY/../$base
625 # do not override scripts
626 if test -x "$symlink_target" &&
627 test ! -d "$symlink_target" &&
628 test "#!" != "$(head -c 2 < "$symlink_target")"
629 then
630 symlink_target=../valgrind.sh
631 fi
632 case "$base" in
633 *.sh|*.perl)
634 symlink_target=../unprocessed-script
635 esac
636 # create the link, or replace it if it is out of date
637 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
638 }
639
640 # override all git executables in TEST_DIRECTORY/..
641 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
642 mkdir -p "$GIT_VALGRIND"/bin
643 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
644 do
645 make_valgrind_symlink $file
646 done
647 OLDIFS=$IFS
648 IFS=:
649 for path in $PATH
650 do
651 ls "$path"/git-* 2> /dev/null |
652 while read file
653 do
654 make_valgrind_symlink "$file"
655 done
656 done
657 IFS=$OLDIFS
658 PATH=$GIT_VALGRIND/bin:$PATH
659 GIT_EXEC_PATH=$GIT_VALGRIND/bin
660 export GIT_VALGRIND
661elif test -n "$GIT_TEST_INSTALLED" ; then
662 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
663 error "Cannot run git from $GIT_TEST_INSTALLED."
664 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
665 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
666else # normal case, use ../bin-wrappers only unless $with_dashes:
667 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
668 if ! test -x "$git_bin_dir/git" ; then
669 if test -z "$with_dashes" ; then
670 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
671 fi
672 with_dashes=t
673 fi
674 PATH="$git_bin_dir:$PATH"
675 GIT_EXEC_PATH=$TEST_DIRECTORY/..
676 if test -n "$with_dashes" ; then
677 PATH="$TEST_DIRECTORY/..:$PATH"
678 fi
679fi
680GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
681unset GIT_CONFIG
682GIT_CONFIG_NOSYSTEM=1
683GIT_CONFIG_NOGLOBAL=1
684export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
685
686. ../GIT-BUILD-OPTIONS
687
688GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
689export GITPERLLIB
690test -d ../templates/blt || {
691 error "You haven't built things yet, have you?"
692}
693
694if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
695then
696 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
697 export GITPYTHONLIB
698 test -d ../git_remote_helpers/build || {
699 error "You haven't built git_remote_helpers yet, have you?"
700 }
701fi
702
703if ! test -x ../test-chmtime; then
704 echo >&2 'You need to build test-chmtime:'
705 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
706 exit 1
707fi
708
709# Test repository
710test="trash directory.$(basename "$0" .sh)"
711test -n "$root" && test="$root/$test"
712case "$test" in
713/*) TRASH_DIRECTORY="$test" ;;
714 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
715esac
716test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
717rm -fr "$test" || {
718 GIT_EXIT_OK=t
719 echo >&5 "FATAL: Cannot prepare test area"
720 exit 1
721}
722
723test_create_repo "$test"
724# Use -P to resolve symlinks in our working directory so that the cwd
725# in subprocesses like git equals our $PWD (for pathname comparisons).
726cd -P "$test" || exit 1
727
728this_test=${0##*/}
729this_test=${this_test%%-*}
730for skp in $GIT_SKIP_TESTS
731do
732 to_skip=
733 for skp in $GIT_SKIP_TESTS
734 do
735 case "$this_test" in
736 $skp)
737 to_skip=t
738 esac
739 done
740 case "$to_skip" in
741 t)
742 say_color skip >&3 "skipping test $this_test altogether"
743 say_color skip "skip all tests in $this_test"
744 test_done
745 esac
746done
747
748# Provide an implementation of the 'yes' utility
749yes () {
750 if test $# = 0
751 then
752 y=y
753 else
754 y="$*"
755 fi
756
757 while echo "$y"
758 do
759 :
760 done
761}
762
763# Fix some commands on Windows
764case $(uname -s) in
765*MINGW*)
766 # Windows has its own (incompatible) sort and find
767 sort () {
768 /usr/bin/sort "$@"
769 }
770 find () {
771 /usr/bin/find "$@"
772 }
773 sum () {
774 md5sum "$@"
775 }
776 # git sees Windows-style pwd
777 pwd () {
778 builtin pwd -W
779 }
780 # no POSIX permissions
781 # backslashes in pathspec are converted to '/'
782 # exec does not inherit the PID
783 ;;
784*)
785 test_set_prereq POSIXPERM
786 test_set_prereq BSLASHPSPEC
787 test_set_prereq EXECKEEPSPID
788 ;;
789esac
790
791test -z "$NO_PERL" && test_set_prereq PERL
792test -z "$NO_PYTHON" && test_set_prereq PYTHON
793
794# test whether the filesystem supports symbolic links
795ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
796rm -f y